#include <QtCore>
#include <QtWidgets>

#include "mainwnd.h"

//******************************************************************************
// YMainWnd
//******************************************************************************

// Constructor
YMainWnd::YMainWnd()
: UiDummy((setupUi(this),0)),
  ComboBox(new QComboBox(this)),
  Model(static_cast<QStandardItemModel*>(ComboBox->model()))
{
ToolBar->addWidget(ComboBox);

ComboBox->setMinimumContentsLength(16);
ComboBox->setSizeAdjustPolicy(QComboBox::AdjustToContents);
ComboBox->addItems({"red","orange","yellow","green","blue","violet"});
ComboBox->setCurrentIndex(0);

connect(ComboBox,    QOverload<int>::of(&QComboBox::currentIndexChanged),
        this,                           &YMainWnd::onCurrentIndexChanged);
connect(Test,                           &QAction::triggered,
        this,                           &YMainWnd::onTest);
}

//******************************************************************************

// Destructor
YMainWnd::~YMainWnd()
{
}

//******************************************************************************

void YMainWnd::onCurrentIndexChanged(
  int           iIndex)                 // i  new index
{
qDebug() << iIndex;
}

//******************************************************************************

// Slot: Action "Test" triggered
void YMainWnd::onTest()
{
int currentIndex=ComboBox->currentIndex();
if (currentIndex<0 || currentIndex>=ComboBox->count()) {
  qDebug() << "Invalid current index:" << currentIndex;
  return;
  }

QString currentText=ComboBox->itemText(currentIndex);
if (currentText.isEmpty()) {
  qDebug() << "Invalid current text:" << currentText;
  return;
  }

qDebug() << "Old current index:" << currentIndex;

QStandardItem* item=new QStandardItem(
  currentText[0].isLower() ? currentText.toUpper() : currentText.toLower());
Model->setItem(currentIndex,ComboBox->modelColumn(),item);

qDebug() << "New current index:" << ComboBox->currentIndex();
}

